import numpy as np
from tensorflow.keras import Input

import hw2_utils
from hw2_utils import Splits

# Load data and reshape to 28x28x1 (1 channel). Training, validation, test data
# is then splits.train, splits.valid, splits.test . Within a split, inputs are
# split.X and outputs are split.Y.
splits = Splits(*[
    split._replace(
        X=np.reshape(split.X, (split.X.shape[0], 28, 28, 1))
    )
    for split in hw2_utils.load_mnist()])


def build_model_mnist1():
    """
    Create model as described in exercise. Return the tensorflow.keras.model
    object.
    """

    hw2_utils.exercise(
        andrew_username="someone", # <<< set your andrew username here
        seed=42
    )

    input = Input(shape=(28, 28, 1))

    model = None

    # >>> Start of your code <<<

    # >>> End of your code <<<

    return model


def train_model_mnist1(model, X, Y):
    """ Train the given model over the given instances. """

    hw2_utils.exercise(
        andrew_username="someone", # <<< set your andrew username here
        seed=42
    )

    # >>> Start of your code <<<

    # Please use verbosity=2 for model.fit when generating evaluation log for
    # submission. DO NOT artificially inflate the training time for your first
    # model in order to pass the final test case.

    # >>> End of your code <<<

    return model


def build_model_mnist2():
    """Create model as described in exercise. Return the tensorflow.keras.model
    object."""

    hw2_utils.exercise(
        andrew_username="someone", # <<< set your andrew username here
        seed=42
    )

    input = Input(shape=(28, 28, 1))

    model = None

    # >>> Start of your code <<<

    # >>> End of your code <<<

    return model


def train_model_mnist2(model, X, Y):
    """ Train the given model over the given instances. """

    hw2_utils.exercise(
        andrew_username="someone", # <<< set your andrew username here
        seed=42
    )

    # >>> Start of your code <<<

    # Please use verbosity=2 for model.fit when generating evaluation log for
    # submission.

    # >>> End of your code <<<

    return model
